; ------------------------------------------------------------------------
;
; Routines de gestion de la FAT & VAT virtuelle pour Flash Savior.
; Finalis le 21/04/2001 par Thibaut.
;
; ------------------------------------------------------------------------
;
; Voil enfin mon modeste travail <|:oD
; Certains trucs pourraient tre encore plus optimiss, mais tant
; donn que notre logiciel ne requiert pas une rapidit extrme,
; je ne me suis pas fatigu inutilement :o)
;
;                           ATTENTION :
; + la routine de rcupration demande 2 paramtres,
;   et en renvoie 1 (voir plus bas) !
; + appeler "Initialiser_FATVAT_Virtuelle" au dmarrage du programme !
; + appeler "Archiver_Les_Recups"  la sortie du programme !
;                                                   Thibaut.
;
; ------------------------------------------------------------------------





; *****************************************************************
; ***          Initialisation du fichier de sauvegarde          ***
; ***                    (FAT&VAT simule)                      ***
; *****************************************************************
; ***  Aucun paramtre n'a  tre pass.
; *****************************************************************
Initialiser_FATVAT_Virtuelle:
	movem.l		d0-a6,-(a7)			; on sauve les registres

ChercherBackup:
	ChercheFichier	Nom_Du_Backup,VAT_Add_Backup	; on regarde si le fichier de FAT&VAT virtuelle existe
	cmp.l		#0,VAT_Add_Backup		; s'il existe...
	bne.s		Backup_Existant			; ... on quitte...
	NouveauFichier	Nom_De_Main,Nom_Du_Backup,VAT_Add_Backup	; ... sinon on cre le fichier...
	bsr.s		Creer_Le_Backup			; ... puis on sauvegarde la FAT&VAT
	Archiver	VAT_Add_Backup			; on archive notre bb tout neuf
	bra.s		ChercherBackup			; son adresse a change

Backup_Existant:
	clr.w		Nombre_de_Recups		; aucune rcup n'a t faite encore
	movem.l		(a7)+,d0-a6			; on restaure les registres
	rts						; voil c'est fini :)
; *****************************************************************





; *****************************************************************
; ***    Pour sauvegarder la FAT/VAT, c'est cette routine :)    ***
; *****************************************************************
; ***  Aucun paramtre n'a  tre pass.
; *****************************************************************
Creer_Le_Backup:
	movem.l		d0-a6,-(a7)			; on sauve les registres

	move.w		#doorsos::FolderListHandle,d0	; d0 = handle de la FAT
	DEREF		d0,a2				; a2 = adresse de la FAT
	addq.l		#2,a2				; a2 pointe sur le nombre rel de folders
	move.l		VAT_Add_Backup,a4		; a4 = adresse de l'entre du fichier de Backup dans la FAT
	move.w		12(a4),d4			; d4 = handle de ce fichier
	DEREF		d4,a5				; a5 = adresse du fichier de Backup
	move.w		(a2)+,d5			; d5 = nombre de folders dans la FAT
	Ecrire		VAT_Add_Backup,-2(a2),#0,#2	; on crit ce nombre dans le fichier
	move.w		d5,d4				; d4 = nombre de folders dans la FAT...
	mulu		#14,d4				; d4 = ... *14, donc la longueur de la FAT en octets
	Ecrire		VAT_Add_Backup,(a2),#2,d4	; on recopie la FAT dans le fichier
	add.l		#12,a2				; a2 pointe sur le handle de la premire VAT
	add.l		#16,a5				; a5 pointe sur l'emplacement de la FAT (virtuelle) o sera crite l'adresse (relative) de la premire VAT
	move.w		d4,d2				; d2 = position d'criture...
	addq.w		#2,d2				; ... courante dans le fichier

	move.w		d5,d6				; d6 = nombre d'itrations...
	subq.w		#1,d6				;  ... -1 (pour la recopie des VATs)
for_I_to_LongFAT:
	move.w		(a2),d4				; d4 = handle de la VAT  sauver
	DEREF		d4,a3				; a3 = son adresse
	move.l		(a3)+,d3			; d3.w = nombre de fichiers dans cette VAT
	move.w		d2,(a5)				; criture en FAT de l'adresse (relative) de cette VAT
	Ecrire		VAT_Add_Backup,-2(a3),d2,#2	; on crit la taille de cette VAT dans le fichier
	addq.w		#2,d2				; d2 = position d'criture courante dans le fichier

	move.w		d3,d7				; d7 = nombre d'itrations...
	beq.s		Fin_Copie_VAT			; si VAT vide, on n'a rien  copier
	subq.w		#1,d7				; ... -1 (pour la recopie des entres des variables)
for_J_to_LongVAT:
	Ecrire		VAT_Add_Backup,(a3),d2,#12	; criture des 12 premiers octets de l'entre d'une variable
	add.w		#12,d2				; d2 = position d'criture courante dans le fichier
	move.w		12(a3),d0			; d0 = handle de la variable en cours de traitement
	DEREF		d0,a4				; a4 = son adresse
	move.l		a4,Tempo			; Tempo = son adresse
	Ecrire		VAT_Add_Backup,Tempo,d2,#4	; criture de l'adresse (absolue) de notre variable
	addq.w		#4,d2				; d2 = position d'criture courante dans le fichier
	add.l		#14,a3				; a3 = entre de variable suivante
	dbf.s		d7,for_J_to_LongVAT		; on va refaire la manip pour l'entre de variable suivante

Fin_Copie_VAT:
	add.l		#14,a5				; a5 pointe sur l'adresse (relative) de la VAT suivante
	add.l		#14,a2				; a2 pointe sur l'entre de la VAT suivante dans la FAT
	dbf.s		d6,for_I_to_LongFAT		; on va refaire la manip pour l'entre de VAT suivante

	move.w		#$002D,Tempo			; type du fichier flashbak (STRING)
	Ecrire		VAT_Add_Backup,Tempo,d2,#2	; criture du type

	movem.l		(a7)+,d0-a6			; on restaure les registres
	rts						; et la sauvegarde est termine
; *****************************************************************





; *****************************************************************
; ***           Rcupration du fichier slectionn             ***
; *****************************************************************
; *** Ncessite 2 paramtres :
; *** a5 = pointeur sur le nom du folder o se situait le fichier
; *** a6 = pointeur sur le nom du fichier
; *** Renvoie 1 rsultat :
; *** d7.w =
; ***        0 : tout s'est bien pass
; ***        1 : fichier dj archiv
; ***        2 : ex-fichier en RAM donc irrcuprable
; *****************************************************************
recuperation:
	movem.l		d0-d6/a0-a6,-(a7)		; on sauve les registres

	btst.b		#3,11(a6)			; si le fichier tait en RAM...
	beq.s		En_RAM				; on ne peut pas le restaurer
	NouveauFichier	(a5),(a6),a4			; on re-cre la variable invisible
	move.l		12(a6),a3			; a3 pointe sur la variable blagueuse
	Ecrire		a4,2(a3),#0,(a3)		; recopie du contenu de la var fantme dans la nouvelle var
	move.w		Nombre_de_Recups,d0		; d0 = nombre de fichiers rcuprs jusqu'ici
	lsl.w		#2,d0				; d0 = adresse relative des coordonnes  ajouter
	lea		Liste_Recups(pc),a6		; a6 pointe sur la liste des vars rcupres
	move.l		a4,0(a6,d0.w)			; criture de l'adresse de l'entre en VAT
	addq.w		#1,Nombre_de_Recups		; mise  jour du nombre de fichiers rcuprs
	bra.s		Fin_Recup
En_RAM:
	move.w		#2,d7				; d7 = fichier disparu

Fin_Recup:
	movem.l		(a7)+,d0-d6/a0-a6		; on restaure les registres
	rts						; voil c'est fini :)
; *****************************************************************





; *****************************************************************
; ***     Archive  la sortie du prog les fichiers rcuprs    ***
; *****************************************************************
; ***  Aucun paramtre n'a  tre pass.
; *****************************************************************
Archiver_Les_Recups:
	movem.l		d0-a6,-(a7)
	lea		Liste_Recups(pc),a2		; a2 pointe sur la liste des vars  archiver
	move.w		Nombre_de_Recups,d2		; d2 = nombre de fichiers  archiver
	beq.s		FinArchivage			; si aucun on quitte

	subq.w		#1,d2				; -1 pour dbf
Archivage:
	Archiver	(a2)+				; on archive notre copie conforme de la variable fantme
	dbf.s		d2,Archivage			; archivage du fichier suivant

FinArchivage:
	movem.l		(a7)+,d0-a6
	rts
; *****************************************************************





; *****************************************************************
; ***                Construction de fichiers                   ***
; *****************************************************************
; *** Ncessite 2 paramtres :
; *** a0 = pointeur sur le nom du folder du future fichier
; *** a1 = pointeur sur le nom du fichier
; *** Retourne 2 rsultats :
; *** a0 = pointeur sur l'entre du fichier dans la VAT
; *** d7.w = 
; ***        0 : opration effectue avec succs
; ***        1 : fichier dj existant
; *****************************************************************
Construire_Fichier:
	movem.l		d0-d6/a1-a6,-(a7)		; on sauve les registres

Chercher_Folder:
	move.w		#doorsos::FolderListHandle,d0	; d0 = handle de la liste de folders du TIOS
	DEREF		d0,a2				; a2 = adresse de cette liste
	move.l		(a2)+,d0			; d0.w = nombre d'lments...

	subq.w		#1,d0				; ... -1 pour dbf
FolderSuivant:
	move.l		a2,a3				; a3 pointe sur un nom de folder dans la FAT
	move.l		a0,a4				; a4 pointe sur le nom du folder recherch

Comparer:
	tst.b		(a4)				; si on est arriv sur la fin du nom...
	beq.s		FinEgaux			; ... c'est qu'on est sur le bon folder
	cmp.b		(a3)+,(a4)+			; comparaison lettre  lettre des noms
	beq.s		Comparer			; si lettres gales, on compare les suivantes

	add.l		#14,a2				; lettres diffrentes. On passe au folder suivant
	dbf.s		d0,FolderSuivant		; et on va comparer notre nom  cet autre folder

	jsr		filelib::createfolder		; le folder demand n'existe pas, on le construit
	bra.s		Chercher_Folder			; on va chercher son handle

FinEgaux:
	move.w		12(a2),d0			; le folder demand a t trouv. On charge son handle dans d0

Creer:
	move.l		a1,a0				; a0 pointe sur le nom du fichier  crer
	jsr		filelib::createfile		; cration proprement dite de la variable
	clr.w		d7				; d7 = opration effectue
	cmp.w		#2,d2				; si le fichier existe dj...
	bne.s		FinCreer
	move.w		#1,d7				; ... on le signale dans d7

FinCreer:
	movem.l		(a7)+,d0-d6/a1-a6		; on restaure les registres
	rts						; et voil :)
; *****************************************************************





; *****************************************************************
; ***   Routine d'actualisation du backup par Julien Monville   ***
; *****************************************************************
; ***  Aucun paramtre n'a  tre pass.
; *** Retourne 1 rsultat :
; *** d7.w = 3 (actualisation complte)
; *****************************************************************
actualiser_backup:
	lea		Nom_Du_Backup(pc),a0			;JM
	clr.w		d1					;JM	a0.l : adress of the VAT entry of the file
	jsr		filelib::search				;JM	d0.w :	handle of the folder of the file
	cmp.w		#0,a0					;JM	
	beq		preparation_FAT_VAT			;JM	c theoriquement impossible

	move.w		12(a0),d2				;JM	handle de FlashBack.
	jsr		filelib::hdltoindex			;JM
	
	;d0.w = folder handle					;JM
	;d1.w = FlashBack index					;JM
	jsr		filelib::unarchive			;JM
	;tst.w		d2					;JM
	;beq		error					;JM
	
	jsr		filelib::delete				;JM
	;tst.w		d2					;JM
	;beq		error					;JM
	move.w		#3,d7					;JM
	bsr		dialogue				;JM
	bra		preparation_FAT_VAT			;JM	recre FlashBack :)
; *****************************************************************

